%% construct eigenvalue problem for Floquet multipliers using full matrices
% indper are 1st and last indices of period interval (corresponding to
% times 0 and 1)
%
% (c) DDE-BIFTOOL v. 3.2a(308), 28/10/2018
%%
function [s,ef]=dde_psol_mult_app_full(Mfun,dim,varargin)
default={'geteigenfuncs',false,'method',[],'closest',[]};
options=dde_set_options(default,varargin,'pass_on');
M=full(Mfun(eye(dim)));
ef=[];
if ~options.geteigenfuncs
    s=eig(M);
else
    [ef,s]=eig(M);
    s=diag(s);
end
if ~isempty(options.closest)
    s=1./s+options.closest;
end